<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8 q-mb-md"
          >
            <translate>The soil data is used to compute the nutrients provided by the soil.</translate>
          </q-banner>

          <q-card-section>
            <q-input
              v-model.number="storeSoilOrganicMatter"
              :label="$gettext('Organic matter content')"
              filled
              type="number"
              :suffix="$gettext('%')"
              :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
              :min="0"
              :max="100"
              :loading="loading"
              step="0.1"
              hide-bottom-space
            />

            <q-input
              v-model.number="storeSoilCaCO3"
              :label="$gettext('CaCO3 content')"
              filled
              type="number"
              :suffix="$gettext('%')"
              :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
              :min="0"
              :max="100"
              :loading="loading"
              step="0.1"
              hide-bottom-space
              class="q-mt-md"
            />

            <q-input
              v-model.number="storeSoilDensity"
              :label="$gettext('Soil density')"
              filled
              type="number"
              :suffix="$gettext('g/cm3')"
              :rules="[val => (val >= 0) || $gettext('This field value must be positive')]"
              :loading="loading"
              step="1"
              hide-bottom-space
              class="q-mt-md"
            />

            <q-input
              v-model.number="storeSoilFrontRootDepth"
              :label="$gettext('Soil front depth root')"
              filled
              type="number"
              :suffix="$gettext('cm')"
              :rules="[val => val > 0 || $gettext('This field value must positive')]"
              :min="0"
              :loading="loading"
              step="0.1"
              hide-bottom-space
              class="q-mt-md"
            />

            <q-input
              v-model.number="storeSoilAgrochemicalActiveLayer"
              :label="$gettext('Agrochemical active layer depth')"
              filled
              type="number"
              :suffix="$gettext('cm')"
              :rules="[val => val > 0 || $gettext('This field value must positive')]"
              :min="0"
              :loading="loading"
              step="0.1"
              hide-bottom-space
              class="q-mt-md"
            />
          </q-card-section>

          <q-card-section>
            <div class="text-subtitle2 text-grey-8 q-pb-sm">
              <translate>Soil texture</translate>
            </div>
            <q-input
              v-model.number="storeSoilClay"
              :label="$gettext('Clay content')"
              filled
              type="number"
              :suffix="$gettext('%')"
              :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
              :min="0"
              :max="100"
              :loading="loading"
              step="0.1"
              hide-bottom-space
            />

            <q-input
              v-model.number="storeSoilSand"
              :label="$gettext('Sand content')"
              filled
              type="number"
              :suffix="$gettext('%')"
              :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
              :min="0"
              :max="100"
              :loading="loading"
              step="0.1"
              hide-bottom-space
              class="q-mt-md"
            />

            <q-input
              v-model.number="storeSoilSilt"
              :label="$gettext('Silt content')"
              filled
              type="number"
              :suffix="$gettext('%')"
              :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
              :min="0"
              :max="100"
              :loading="loading"
              step="0.1"
              hide-bottom-space
              class="q-mt-md"
            />

            <div
              v-if="!isSoilTextureValid"
              class="text-body2 text-negative q-mt-md"
            >
              <q-icon
                name="las la-exclamation-circle"
                class="q-mr-sm"
              />
              <translate>The sum of clay, sand and silt contents must be equal to 100.</translate>
            </div>
          </q-card-section>

          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryIcpaPmnConfig from 'src/pages/fieldbook/fertilization/algorithms/icpa-pmn/graphql/queryIcpaPmnConfig'
import querySoilDerivedObjectsByPlotId from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/querySoilDerivedObjectsByPlotId'

export default {
  name: 'IcpaPmnSoilPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  data () {
    return {
      icpaPmnConfig: null,
      plotSoilDerivedPropertyMap: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Soil')
    },
    pageSubTitle () {
      return 'ICPA PMN'
    },
    canContinue () {
      return this.isParameterSet(this.storeSoilOrganicMatter) &&
        this.isParameterSet(this.storeSoilDensity) &&
        this.isParameterSet(this.storeSoilFrontRootDepth) &&
        this.isParameterSet(this.storeSoilClay) &&
        this.isParameterSet(this.storeSoilSand) &&
        this.isParameterSet(this.storeSoilSilt) &&
        this.isParameterSet(this.storeSoilAgrochemicalActiveLayer) &&
        this.isParameterSet(this.storeSoilCaCO3) &&
        this.isSoilTextureValid
    },
    loading () {
      return !this.icpaPmnConfig || !this.plotSoilDerivedPropertyMap
    },
    plotId () {
      return this.$store.state.fertilizationPlan.target.id
    },
    isSoilTextureValid () {
      // there is an error margin for the soil composition
      const soilCompositionErrorMargin = this.icpaPmnConfig?.maximum_soil_clay_sand_silt_tolerance_to_100 ?? 5
      const totalSoilTexturePct = this.storeSoilClay + this.storeSoilSand + this.storeSoilSilt
      return totalSoilTexturePct >= (100 - soilCompositionErrorMargin) && totalSoilTexturePct <= (100 + soilCompositionErrorMargin)
    },
    storeSoilOrganicMatter: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilOrganicMatter
      },
      set (v) {
        this.updateParameter('soilOrganicMatter', v)
      }
    },
    storeSoilDensity: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilDensity
      },
      set (v) {
        this.updateParameter('soilDensity', v)
      }
    },
    storeSoilFrontRootDepth: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilFrontRootDepth
      },
      set (v) {
        this.updateParameter('soilFrontRootDepth', v)
      }
    },
    storeSoilClay: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilClay
      },
      set (v) {
        this.updateParameter('soilClay', v)
      }
    },
    storeSoilSand: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilSand
      },
      set (v) {
        this.updateParameter('soilSand', v)
      }
    },
    storeSoilSilt: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilSilt
      },
      set (v) {
        this.updateParameter('soilSilt', v)
      }
    },
    storeSoilAgrochemicalActiveLayer: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilAgrochemicalActiveLayer
      },
      set (v) {
        this.updateParameter('soilAgrochemicalActiveLayer', v)
      }
    },
    storeSoilCaCO3: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilCaCO3
      },
      set (v) {
        this.updateParameter('soilCaCO3', v)
      }
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadData('cache-first')

    // Set default values from the plot soil derived observations or from the config
    if (!this.isParameterSet(this.storeSoilOrganicMatter)) {
      this.storeSoilOrganicMatter = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.organic_matter, 2) ?? this.toNumber(this.icpaPmnConfig?.default_soil_organic_matter)
    }
    if (!this.isParameterSet(this.storeSoilDensity)) {
      this.storeSoilDensity = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.bulk_density, 2) ?? this.toNumber(this.icpaPmnConfig?.default_soil_density)
    }
    if (!this.isParameterSet(this.storeSoilFrontRootDepth)) {
      this.storeSoilFrontRootDepth = this.toNumber(this.icpaPmnConfig?.default_soil_front_root_depth)
    }
    if (!this.isParameterSet(this.storeSoilClay)) {
      this.storeSoilClay = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.clay, 1) ?? this.toNumber(this.icpaPmnConfig?.default_soil_clay)
    }
    if (!this.isParameterSet(this.storeSoilSand)) {
      this.storeSoilSand = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.sand, 1) ?? this.toNumber(this.icpaPmnConfig?.default_soil_sand)
    }
    if (!this.isParameterSet(this.storeSoilSilt)) {
      this.storeSoilSilt = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.silt, 1) ?? this.toNumber(this.icpaPmnConfig?.default_soil_silt)
    }
    if (!this.isParameterSet(this.storeSoilAgrochemicalActiveLayer)) {
      this.storeSoilAgrochemicalActiveLayer = this.toNumber(this.icpaPmnConfig?.default_soil_agrochemical_active_layer)
    }
    if (!this.isParameterSet(this.storeSoilCaCO3)) {
      this.storeSoilCaCO3 = this.roundIfNeeded(this.plotSoilDerivedPropertyMap?.caco3, 1) ?? this.toNumber(this.icpaPmnConfig?.default_soil_caco3)
    }

    // Refresh online data (do not wait until completion)
    this.loadData('network-only')
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'icpaPmnLivestock'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'icpaPmnHarvestAndResidues'
      })
    },
    roundIfNeeded (number, decimalPlaces = 0) {
      if (number == null) {
        return number
      } else {
        const factorOfTen = Math.pow(10, decimalPlaces)
        return Math.round(number * factorOfTen) / factorOfTen
      }
    },
    toNumber (val) {
      return val != null ? Number(val) : null
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryIcpaPmnConfig,
        fetchPolicy
      })
      this.icpaPmnConfig = data?.icpa_pmn__config
    },
    async loadSoilProperties (fetchPolicy) {
      try {
        const { data } = await this.$apollo.query({
          query: querySoilDerivedObjectsByPlotId,
          variables: {
            plot_id: this.plotId
          },
          fetchPolicy
        })
        this.plotSoilDerivedPropertyMap = {}
        const derivedObservations = data?.soil_derived_object?.[0]?.derived_observations || []
        for (const observation of derivedObservations) {
          this.plotSoilDerivedPropertyMap[observation.observed_property_id] = observation.result.value || null
        }
      } catch (e) {
        console.error('Could not load soil properties', e)
        this.plotSoilDerivedPropertyMap = {}
      }
    },
    loadData (fetchPolicy) {
      return Promise.all([
        this.loadConfig(fetchPolicy),
        this.loadSoilProperties(fetchPolicy)
      ])
    }
  }
}
</script>
